const std = @import("std");

const Uxn = @import("uxn.zig");
const Varvara = @This();

uxn: Uxn,

pub fn init(rom: []const u8) Varvara {
    var uxn = Uxn{ .pc = 0x100 };
    @memcpy(uxn.mem.m[0x100 .. rom.len + 0x100], rom);
    return .{ .uxn = uxn };
}

pub fn deo8(uxn: *Uxn, stack: *Uxn.Stack, device: u8, value: u8) void {
    const self: Varvara = @fieldParentPtr("uxn", uxn);
    // _ = .{ self, stack, device, value };
    _ = self;
    _ = stack;
    switch (device) {
        0x18 => {
            std.io.getStdOut().writer().writeByte(value) catch |e| @panic(e);
        },
        else => {},
    }
}

pub fn deo16(uxn: *Uxn, stack: *Uxn.Stack, device: u8, value: u16) void {
    const self: Varvara = @fieldParentPtr("uxn", uxn);
    _ = .{ self, stack, device, value };
}

pub fn dei8(uxn: *Uxn, stack: *Uxn.Stack, device: u8, value: u8) void {
    const self: Varvara = @fieldParentPtr("uxn", uxn);
    _ = .{ self, stack, device, value };
}

pub fn dei16(uxn: *Uxn, stack: *Uxn.Stack, device: u8, value: u16) void {
    const self: Varvara = @fieldParentPtr("uxn", uxn);
    _ = .{ self, stack, device, value };
}
